-module(pingpong_done).
-export([main/0, server/1]).

% Since the functions were (basically) identical, we can create a more general
% function. It takes what it should print (ping or pong) as parameter.
server(Msg) ->
    receive
        From ->
            Myself = self(),
            io:fwrite("~p: ~p~n", [Myself, Msg]),
            timer:sleep(1500),
            From ! Myself
    end,
    server(Msg).

main() ->
    % Different way of spawning processes, if we need to give it arguments.
    % Order or parameters to spawn:
    %    module where the function is located
    %    function name
    %    list of parameters to the function
    Ping = spawn(pingpong_done, server, [ping]),
    Pong = spawn(pingpong_done, server, [pong]),
    Ping ! Pong,
    ok.
